
package de.ivu.elect.presentation.wahlvorschlag.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.WusFeaturesAktiviert;
import de.ivu.elect.business.kandidatur.boundary.WaehlerBenannteKandidaturKonfiguration;
import de.ivu.elect.business.wahlvorschlag.boundary.ListeChangeEvent;
import de.ivu.elect.business.wahlvorschlag.boundary.ListeExtendedDAO;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.presentation.menu.AbstractActionEntry;
import de.ivu.elect.presentation.wahl.CurrentWahlZulassungspruefungExtended;

public abstract class AbstractListeAction extends AbstractActionEntry<Liste> {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WusFeaturesAktiviert wusFeaturesAktiviert;

  @Inject
  private transient CurrentWahlZulassungspruefungExtended currentWahlZulassungspruefung;

  @Inject
  private transient WaehlerBenannteKandidaturKonfiguration waehlerBenannteKandidaturKonfiguration;

  @Inject
  private transient ListeExtendedDAO listeExtendedDAO;

  @Inject
  private transient ListeChangeEvent listeChangeEvent;

  public AbstractListeAction() {
    super();
  }

  @Override
  protected boolean isDisabledInternal(@Nonnull Liste liste) {
    return isWaehlerBenannteListe(liste); // Aktionen auf "Wähler benannten Personen" explizit zulassen!
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  protected void fireChangeEvent() {
    listeChangeEvent.sendChangeEvent();
  }

  @Override
  protected Liste attach(Liste liste) {
    return listeExtendedDAO.attach(liste);
  }

  public CurrentWahlZulassungspruefungExtended getCurrentWahlZulassungspruefung() {
    return currentWahlZulassungspruefung;
  }

  protected boolean isEinzelbewerberListe(Liste liste) {
    return liste != null && attach(liste).isEinzelbewerber();
  }

  protected boolean isWaehlerBenannteListe(Liste liste) {
    return waehlerBenannteKandidaturKonfiguration.isWaehlerBenannteListe(liste);
  }

  protected boolean isNurWas() {
    return getWusFeaturesAktiviert().isNurWas();
  }

  protected boolean isWusOderWusWasZusammen() {
    return getWusFeaturesAktiviert().isWusOderWusWasZusammen();
  }

  protected WusFeaturesAktiviert getWusFeaturesAktiviert() {
    return wusFeaturesAktiviert;
  }
}
